<?php

DB::connect()->query('SET foreign_key_checks = 0');

$sql_query=  DB::connect()->query("SHOW TABLES LIKE 'old_version_gr_users'")->fetchAll();
$second_query=  DB::connect()->query("SHOW TABLES LIKE 'gr_site_users'")->fetchAll();
$stop_process=false;

if (count($sql_query) == 0 && count($second_query) == 0) {
    $sql_query=  DB::connect()->query("SHOW TABLES LIKE 'gr_%'")->fetchAll();
    foreach ($sql_query as $db_table) {
        $table_name=$db_table[0];
        $new_table_name = 'old_version_'.$table_name;
        $query='ALTER TABLE '.$table_name.' RENAME TO '.$new_table_name;
        $sql_query=  DB::connect()->query($query);
    }
}

if (count($second_query) == 0) {
    $db_file=file_get_contents('upgrade_image/layouts/installer/installer.sql');
    try {
        DB::connect()->query($db_file);
    } catch (PDOException $exception) {
        $page_content = [
               'title' => 'Error',
               'page_content' => 'Importing Database Failed',
               'heading' => 'Oops',
               'page_status' => 'error',
               'button_text' => 'Reload',
               'button_link' => 'index.php?process=initial'
    ];
        $stop_process=true;
        add_to_error_log($exception->getMessage());
    }
}

if (!$stop_process) {
    if (isset($_GET['sub_process']) && !empty($_GET['sub_process'])) {
        $sub_process_file='processes/sub_processes/version_2/'.$_GET['sub_process'].'.php';
        if (file_exists($sub_process_file)) {
            include($sub_process_file);
        }
    } else {
        try {
            $drop_tables="DROP TABLE IF EXISTS old_version_gr_alerts,old_version_gr_complaints,";
            $drop_tables.="old_version_gr_customize,old_version_gr_logs,";
            $drop_tables.="old_version_gr_session,old_version_gr_utrack,old_version_gr_mails;";

            DB::connect()->query($drop_tables);
        } catch (PDOException $exception) {
        }

        $page_content = [
            'title' => 'Importing Site Roles',
            'loading_text' => 'Importing Site Roles',
            'subtitle' => 'Please Wait',
            'redirect' => 'index.php?process=update_database&sub_process=site_roles'
        ];
    }
}

DB::connect()->query('SET foreign_key_checks = 1');
